## ---------------------------------------------------------------------------------------
# TASK1: GO ON FIT AN AR model with lm: what order? do some validation
## ---------------------------------------------------------------------------------------
fit <- lm(y ~ 0 + y.l1, D)
summary(fit)
validate(fit)

fit <- lm(y ~ 0 + y.l1 + y.l2, D)
summary(fit)
validate(fit)

fit <- lm(y ~ 0 + y.l1 + y.l2 + y.l3, D)
summary(fit)
res <- validate(fit)

fit <- lm(y ~ 0 + y.l1 + y.l2 + y.l3 + y.l4, D)
summary(fit)
res <- validate(fit)

fit <- lm(y ~ 0 + y.l1 + y.l2 + y.l3 + y.l4 + y.l5, D)
summary(fit)
res <- validate(fit)

# Difference in residuals?
plot(resMarima - res)

stophere










































## ---------------------------------------------------------------------------------------
# TASK2: How can we actually add the LAGGED residuals to the AR model and make it an ARMA!?
## ---------------------------------------------------------------------------------------
# How can we get the lagged residuals!?
fit <- lm(y ~ 0 + y.l1, D)
res <- validate(fit)
D$MA.l1 <- lagvec(res, 1)

# Now use them as input
fit <- lm(y ~ 0 + y.l1 + MA.l1, D)

validate(fit)

# Estimates?
summary(fit)
summary(fitMarima)


# How did it go with the predictions?
plot(D$y, type="b")
lines(predict(fit, newdata=D), col=4)  
lines(D$y - resMarima, col=2)
legend("topright", c("y","Our predictions","Marima"), lty=1, col=c(1:2,4))

stophere


# What if we do it again with the new residuals!?
D

# First once
fit <- lm(y ~ 0 + y.l1, D)
res <- validate(fit)
D$MA.l1 <- lagvec(res, 1)
res[2] <- res[3]
fit <- lm(y ~ 0 + y.l1 + MA.l1, D)
summary(fit)

# Then repeat
res <- validate(fit)
res[2] <- res[3]
D$MA.l1 <- lagvec(res, 1)
fit <- lm(y ~ 0 + y.l1 + MA.l1, D)
summary(fit)

# Estimates?
summary(fit)
summary(fitMarima)


# How did it go with the predictions?
plot(D$y, type="b")
lines(predict(fit, newdata=D), col=4)  
lines(D$y - resMarima, col=2)
legend("topright", c("y","Our predictions","Marima"), lty=1, col=c(1:2,4))

stophere


# To get exactly what marima does
# First once, now use ARIMA to initialize
fit <- arima(D$y, order=c(3,0,0))
res <- validate(fit)
D$MA.l1 <- lagvec(res, 1)
fit <- lm(y ~ 0 + y.l1 + MA.l1, D)
summary(fit)

# Keep the first residuals
resinit <- res

# Then repeat
for(i in 1:50){
  res <- validate(fit)
  D$MA.l1 <- lagvec(res, 1)
  D$MA.l1[2] <- resinit[1]  
  fit <- lm(y ~ 0 + y.l1 + MA.l1, D)
}
# Compare the estimates
summary(fit)
summary(fitMarima)


# How did it go with the predictions?
plot(D$y, type="b")
lines(predict(fit, newdata=D), col=4, lwd=6)  
lines(D$y - resMarima, col=2, lwd=2)
legend("topright", c("y","Our predictions","Marima"), lty=1, col=c(1:2,4))