# First once: use ARIMA to initialize
fit <- arima(D$y, order=c(3,0,0), xreg=D$x)
res <- validate(fit)
D$MA.l1 <- lagvec(res, 1)
fit <- lm(y ~ 0 + y.l1 + x.l1 + MA.l1, D)
summary(fit)

# Keep the first residuals
resinit <- res

# Then repeat
res <- validate(fit)
D$MA.l1 <- lagvec(res, 1)
D$MA.l1[2] <- resinit[1]
#D$MA.l1[2] <- 0
fit <- lm(y ~ 0 + y.l1 + x.l1 + MA.l1, D)
fit

summary(fit)
summary(fitMarima)

# How did it go with the predictions?
plot(D$y, type="b")
lines(predict(fit, newdata=D), col=4)  
lines(D$y - resMarima, col=2)
legend("topright", c("y","Our predictions","Marima"), lty=1, col=c(1:2,4))



## ---------------------------------------------------------------------------------------
# What happens really with the arima with the xreg argument!?

# Estimate with arima
x1 <- lagvec(x,1)
x1[1] <- 0
(fitArima <- arima(y, order=c(1,0,1), xreg=x1, include.mean=FALSE))

?arima
(fit <- lm(y ~ 0 + x1))
(fitArima2 <- arima(fit$residuals, order=c(1,0,1), include.mean=FALSE))

plot(fitArima$residuals - fitArima2$residuals)
plot(fitArima$residuals - fitMarima$residuals[1, ])

# I don't know!
